﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Illsutration_struct
{

    public class poutre
    {
        private double _largeur;
        private double _longueur;
        private double _hauteur;
        private double _diamètre;
        private string _reference;

        public double largeur
            {
            get
            { return _largeur; }
            set { if (value > 0)
            { _largeur = value; }
                else { Console.WriteLine("largeur valeur n'est pas positive"); }
            }
        }

        public double longueur
        {
            get
            { return _longueur; }
            set
            {
                if (value > 0)
                { _longueur = value; }
                else { Console.WriteLine("longueur valeur n'est pas positive"); }
            }
        }

        public double hauteur
        {
            get
            { return _hauteur; }
            set
            {
                if (value > 0)
                { _hauteur = value; }
                else { Console.WriteLine("hauteur valeur n'est pas positive"); }
            }
        }

        public double diamètre
        {
            get
            { return _diamètre; }
            set
            { if (value > 0)
                { _diamètre = value; }
            else { Console.WriteLine("diamètre valeur n'est pas positive"); }
            }
        }
        public string reference
        {
            get
            { return _reference; }
            set
            { _reference = value; }
        }

        public poutre()
        {
            longueur = 0;
            largeur = 0;
            hauteur = 0;
            diamètre = 0;
            reference = "Unknown";
        }



        public poutre(double param_long, double param_larg, double param_hauteur, double param_diam, string param_ref)
        {
            longueur = param_long;
            largeur = param_larg;
            hauteur = param_hauteur;
            diamètre = param_diam;
            reference = param_ref;
        }



        public poutre copy_poutre()
        {
            poutre res = new poutre(); // instanciation
            res.longueur = longueur;
            res.largeur = largeur;
            res.hauteur = hauteur;
            res.diamètre = diamètre;
            res.reference = reference;
            return (res);

        }

        public void affich_poutre()
        {
            Console.Write("Poutre de longueur :"); Console.WriteLine(longueur);
            Console.Write("Poutre de largeur :"); Console.WriteLine(largeur);
            Console.Write("Poutre de hauteur :"); Console.WriteLine(hauteur);
            Console.Write("Poutre avec féraillage de  diamètre  :"); Console.WriteLine(diamètre);
            Console.Write("Référence de la Poutre :"); Console.WriteLine(reference);
            Console.ReadLine();
        }


    }


    public class linteau : poutre
    {
        // le constructeur de linteau appelle le constructeur de poutre avec le mot clef "base"
             public linteau(string refe): base(120, 40, 40, 1, refe)
            { }

     }


    class Program
    {
        

        static void Main(string[] args)
        {

            poutre poutre_cuis = new poutre(100, 40, 50, 2, "POUTRE-CUIS");

            linteau lint_cuis = new linteau("LINT_3");

            lint_cuis.affich_poutre();

            poutre_cuis.affich_poutre();
        }

        
    }
}
